/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : April, 1997                                                    */
/* File Name : JSSPReader.cc                                             */
/*************************************************************************/
/*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>

#include "JSSPReader.h"
#include "JSSProblem.h"
#include "Operation.h"

JSSPReader::JSSPReader()
{  sprintf(FileName,"%s","input.jssp"); 
}// end of constructor

JSSPReader::~JSSPReader()
{  cout << " de allocate JSSPReader " << endl; 
}// end of constructor

JSSPReader::JSSPReader(char *_fileName)
{  sprintf(FileName,"%s",_fileName); 
   printf("File name is %s",_fileName); 
}// end of constructor

void JSSPReader::setFileName(char *_fileName)
{  sprintf(FileName,"%s",_fileName); 
}// end of constructor

JSSProblem JSSPReader::read()
{  
   int facilityNumber,TimeRequired;
   int i,j;
   ifstream fileIn(FileName);

   fileIn >> NumberOfFacilities;
   fileIn >> NumberOfJobs;

   JSSProblem ret(NumberOfFacilities,NumberOfJobs);

   for(i=0;i<NumberOfJobs;i++)
   {  
      OperationList Job(i,NumberOfFacilities);

      for(j=0;j<NumberOfFacilities;j++)
      {  fileIn >> facilityNumber;
	 //fileIn >> ch;
	 fileIn >> TimeRequired;
	 Operation newOP(i,j,facilityNumber,TimeRequired);
	 Job.addOperation(newOP);
      }// end of for

   }// end of for

   fileIn.close();

   return ret;

}// end of read()

void JSSPReader::read(JSSProblem& ret)
{  
   int facilityNumber,TimeRequired;
   int i,j;
   ifstream fileIn(FileName);

   cout << " File name is " << FileName << endl;

   fileIn >> NumberOfJobs;
   fileIn >> NumberOfFacilities;

   ret.setNumberOfFacilities(NumberOfFacilities);
   ret.setNumberOfJobs(NumberOfJobs);

   cout << " Number of Facilities :" << NumberOfFacilities << endl;
   cout << " Number of Jobs :" << NumberOfJobs << endl;

   for(i=0;i<NumberOfJobs;i++)
   {  
      cout << endl << i << "row";
      OperationList Job(i,NumberOfFacilities);

      for(j=0;j<NumberOfFacilities;j++)
      {  fileIn >> facilityNumber;
	 fileIn >> TimeRequired;
	 Operation newOP(i,j,facilityNumber,TimeRequired);
	 Job.addOperation(newOP);

	 //cout << " I add " << j << " th operation " << endl;
      }// end of for

      //cout << " Before I add to Problem " << endl;
      ret.addJob(Job);
      //cout << " I added to Problem " << endl;

   }// end of for

   fileIn.close();

}// end of read()


